<?php
require_once(dirname(dirname(dirname(dirname(dirname(__FILE__))))) . '/config.php');
require_once(dirname(__FILE__) . '/upload_form.php');
require_once(dirname(__FILE__) . '/assignment.class.php');
require_once("$CFG->dirroot/repository/lib.php");

$contextid = required_param('contextid', PARAM_INT);
$id = optional_param('id', null, PARAM_INT);
$audio = optional_param('audio', null, PARAM_INT);

$formdata = new stdClass();
$formdata->userid = required_param('userid', PARAM_INT);
$formdata->offset = optional_param('offset', null, PARAM_INT);
$formdata->forcerefresh = optional_param('forcerefresh', null, PARAM_INT);
$formdata->mode = optional_param('mode', null, PARAM_ALPHA);

$url = new moodle_url('/mod/assignment/type/nanogong/record.php', array('contextid' => $contextid, 'id' => $id, 'offset' => $formdata->offset, 'forcerefresh' => $formdata->forcerefresh, 'userid' => $formdata->userid, 'mode' => $formdata->mode));

list($context, $course, $cm) = get_context_info_array($contextid);

if (!$assignment = $DB->get_record('assignment', array('id' => $cm->instance)))
{
    print_error('invalidid', 'assignment');
}
require_login($course, true, $cm);

if (isguestuser())
{
    die();
}

$instance = new assignment_nanogong($cm->id, $assignment, $cm, $course);
$submission = $instance->get_submission($USER->id);
if($audio != null) //UPLOAD a audio request from ajax
{
    if ($submission)
    {
        if($instance->assignment->resubmit==0)
        {
           // die('not allowed to resend ');
        }
    }

    $instance->upload_audio();
    die();
}

$fullname = format_string($course->fullname, true, array('context' => get_context_instance(CONTEXT_COURSE, $course->id)));

$PAGE->set_url($url);
$PAGE->set_context($context);
$title = strip_tags($fullname . ': ' . get_string('modulename', 'assignment') . ': ' . format_string($assignment->name, true));
$PAGE->set_title($title);
$PAGE->set_heading($title);
$PAGE->requires->string_for_js('complete', 'nanogong');
$PAGE->requires->js_init_call('initNanoGong',array($CFG->wwwroot.'/mod/assignment/type/nanogong/record.php?contextid='.$contextid.'&id='.$cm->id.'&userid='.$formdata->userid.'&audio=1'));
$PAGE->requires->js('/mod/nanogong/js/nanogong.js');

$mform = new mod_assignment_nanogong_form(null, array('contextid' => $contextid, 'userid' => $formdata->userid));

if ($mform->is_cancelled())
{
    redirect(new moodle_url('/mod/assignment/view.php', array('id' => $cm->id)));
}
else if ($data = $mform->get_data())
{
   // $instance->upload($mform);
    if($submission)
    {
        $updates = new stdClass();
        $updates->id = $submission->id;
        $updates->data1 = $data->message;
        $DB->update_record('assignment_submissions', $updates);
    }
    redirect(new moodle_url('/mod/assignment/view.php', array('id' => $cm->id)));
    die();
}

echo $OUTPUT->header();
echo $OUTPUT->box_start('generalbox');
echo getNanogongPlayer($cm->id);
$mform->display();
echo $OUTPUT->box_end();
echo $OUTPUT->footer();
