<?php

defined('MOODLE_INTERNAL') || die;

require_once($CFG->dirroot . '/course/moodleform_mod.php');
require_once($CFG->libdir . '/filelib.php');

class mod_nanogong_mod_form extends moodleform_mod
{

    function definition()
    {
        global $CFG, $DB,$USER,$PAGE;
        $mform = & $this->_form;
        $usercontext = get_context_instance(CONTEXT_USER, $USER->id);
        $config = get_config('nanogong');
        $time = time();
        //-------------------------------------------------------
        $mform->addElement('header', 'general', get_string('general', 'form'));
        $mform->addElement('text', 'name', get_string('name'), array('size' => '48'));
        $mform->addElement('hidden','time',$time);
        $mform->addElement('hidden','usercontextid',$usercontext->id);
        if (!empty($CFG->formatstringstriptags))
        {
            $mform->setType('name', PARAM_TEXT);
        }
        else
        {
            $mform->setType('name', PARAM_CLEANHTML);
        }
        $mform->addRule('name', null, 'required', null, 'client');
        $this->add_intro_editor();
        //-------------------------------------------------------
        $mform->addElement('header', 'contentsection', get_string('contentheader', 'nanogong'));

        //------------------------PLAYER

        $PAGE->requires->string_for_js('complete', 'nanogong');

        $PAGE->requires->js_init_call('initNanoGong',array($CFG->wwwroot.'/mod/nanogong/addrecord.php?time='.$time.'&contextid='.$usercontext->id.'&id='.$this->current->module.'&userid='.$USER->id.'&audio=1'));
        $PAGE->requires->js('/mod/nanogong/js/nanogong.js');

        $mform->addElement('html',getNanogongPlayer($usercontext));

        $mform->addElement('button', 'button',get_string('save','assignment_nanogong'),array('id'=>'sendAudio'));

        //-------------------------------------------------------
        $this->standard_coursemodule_elements();

        //-------------------------------------------------------
        $this->add_action_buttons();

        //-------------------------------------------------------
    }

    function validation($data)
    {
        global $USER,$DB;
        $errors ='';

        $usercontext = get_context_instance(CONTEXT_USER, $USER->id);
        $fs = get_file_storage();

        if (!$files = $fs->get_area_files($usercontext->id, 'nanogong', 'nanogong_source', $data['time']))
        {
         //   $errors['button'] = get_string('required');
            return $errors;
        }
        if (count($files) > 1)
        {

            return $errors;
        }

        return $errors;
    }

}
